from multiprocessing import active_children

from cml import construction
from cml.ports.source_adapters import PandasBlock
from cml.domain.construction import Constructor
from cml.shared.settings import specific_settings_factory


def test_starting_background_constructor():
    # arrange
    from sklearn.cluster import SpectralClustering
    algos = [("Spec", SpectralClustering())]
    mode = "conceptual"
    constructor = construction(mode, algos)

    learnblock = PandasBlock.read_csv("./test_toyset.csv")

    # act
    constructed = constructor.construct_parallel(learnblock)

    # assert
    next(iter(constructed))
    child = active_children().pop()
    assert child.name == "BackgroundConstructor"


